/*
 *  Copyright (c) 2009 Luca Abeni
 *
 *  This is free software; see gpl-3.0.txt
 */

#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>

#include "chunk.h"
#include "input.h"
#include "output.h"
#include "lost.h"

int main(int argc, char *argv[])
{
  int csize = 1024 * 24; /* about 1s at 200kbps */
  int done, cnt, cntlost, sumsize;
  void *in, *out;

  if (argc > 4) {
    csize = atoi(argv[4]);
  }
  printf("Chunk size: %d bytes\n", csize);
  in = input_stream_open(argv[1], csize);
  if (in == NULL) {
    fprintf(stderr, "Cannot open input file!\n");

    return -1;
  }
  out = output_stream_open(argv[2]);
  if (out == NULL) {
    fprintf(stderr, "Cannot open output file!\n");

    return -1;
  }
  lost_chunks(argv[3]);

  done = 0; cnt = 0; cntlost = 0; sumsize = 0;
  while(!done) {
    struct chunk ch;
    int frames;

    frames = chunk_read(in, &ch);
    if (frames) {
      if (!is_lost(cnt++)) {
fprintf(stderr, "Read %d - Writing %d --- %d\t", frames, cnt - 1, sumsize);
        sumsize += chunk_write(out, &ch, frames);
fprintf(stderr, "%d\n", sumsize);
      } else {
        cntlost++;
fprintf(stderr, "Skipping %d\n", cnt - 1);
      }
    } else {
      done = 1;
    }
  }
  sumsize += output_stream_flush(out);
fprintf(stderr, "bytes: %d\nchunks: %d\nchunkslost: %d\n", sumsize, cnt, cntlost);

  return 0;
}
