/*
 *  Copyright (c) 2009 Luca Abeni
 *
 *  This is free software; see gpl-3.0.txt
 */

#include <stdio.h>

#include "lost.h"

#define MAX_LOST_CHUNKS 10000

static int lost[MAX_LOST_CHUNKS];

int lost_chunks(const char *fname)
{
  int i;
  FILE *f;

  f = fopen(fname, "r");
  if (f == NULL) {
    return -1;
  }

  for (i = 0; i < MAX_LOST_CHUNKS; i++) {
    lost[i] = -1;
  }

  i = 0;
  while (!feof(f) && (i < MAX_LOST_CHUNKS)) {
    int res;

    res = fscanf(f, "%d", &lost[i]);
    if (res == 1) {
      i++;
    }
  }
  fclose(f);

  return i;
}

int is_lost(int c)
{
  int i;

  for (i = 0; lost[i] >= 0; i++) {
    if (lost[i] == c) {
      return 1;
    }
  }

  return 0;
}
